#include <GUIConstants.au3>
#include <string.au3>

Global $folder1, $folder3, $folder4, $targetfile, $targetfolder, $archivefile, $compress, $compress1, $bsdtar	;   

Opt ( "GUIOnEventMode", 1 )														; GUI    Event Mode

GUICreate ( "  bsdtar", 330, 140 )										;   
GUISetBkColor(0x00E0FFFF)														;   

$source = GUICtrlCreateButton ( " ",  10, 10, 100 )					;     
GUICtrlSetOnEvent ( $source, "GetSource")										;     GetSource

$compress = GUICtrlCreateCheckbox ( " ", 230, 12, 100, 20 )

$fragment = GUICtrlCreateCombo ( "   ...", 10, 42, 150, 20 )
GUICtrlSetData ( $fragment, "100 MB|1 GB" )

$target = GUICtrlCreateButton ( " ...",  120, 10, 100 )				;    
GUICtrlSetOnEvent ( $target, "GetTarget")										;     GetTarget

$beginpack = GUICtrlCreateButton ( " ", 170, 40, 150 )					;    
GUICtrlSetState ( $beginpack, $GUI_DISABLE )									;   
GUICtrlSetOnEvent ( $beginpack, "Pack" )										;     Pack

$archive = GUICtrlCreateButton ( " ", 10, 70, 150 )					;    
GUICtrlSetOnEvent ( $archive, "GetArchive" )									;     GetArchive

$unpack = GUICtrlCreateButton ( " ...", 170, 70, 150 )				;      
GUICtrlSetOnEvent ( $unpack, "UnpackTo" )										;     UnpackTo

$beginunpack = GUICtrlCreateButton ( " ", 10, 100, 310 )				;    
GUICtrlSetState ( $beginunpack, $GUI_DISABLE )									;   
GUICtrlSetOnEvent ( $beginunpack, "Unpack" )									;     Unpack

GUISetOnEvent ( $GUI_EVENT_CLOSE, "CLOSEClicked" )								;  CLOSEClicked    
GUISetState ()																	; 



Func GetSource ()
$folder1 =  FileSelectFolder(" ,    ", "", 2, "O:\SASPlanet\cache\" )	;     
$folder2 = StringInStr ( $folder1, "\", 0, -1 )									;       "\"
$folder3 = StringMid ( $folder1, $folder2 +1 ) 									;     
$folder4 = StringTrimRight ( $folder1, StringLen ( $folder1 ) - $folder2 )		;     
If $targetfile <> "" Then														;      ,
	GUICtrlSetState ( $beginpack, $GUI_ENABLE )									;    ""
	EndIf
EndFunc


Func GetTarget ()
$targetfile =  FileSaveDialog ("      ", "", "(*.tar;*.tgz)", 16 )	;    
EndFunc

Func Pack ()
	$compress1 = GUICtrlRead ( $compress )
If $compress1 = 1 Then																;   
	$ext_tgz = StringInStr ( $targetfile, ".tgz" )									; ,      .tgz
	If $ext_tgz = 0 Then															;   ,
	$targetfile = $targetfile & ".tgz"												;  
	Endif
EndIf
If $compress1 = 4 Then																;    
	$ext_tar = StringInStr ( $targetfile, ".tar" )									; ,      .tar
	If $ext_tar = 0 Then															;   ,
	$targetfile = $targetfile & ".tar"												;  
	Endif
EndIf	
If $folder3 <> "" Then																;    -,
	GUICtrlSetState ( $beginpack, $GUI_ENABLE )										;    ""
	EndIf
	$bsdtarfolder = StringTrimRight ( @AutoItExe, 14 )								;  ,      bsdtar.exe
	$bsdtar = $bsdtarfolder & "\bsdtar.exe"											;     bsdtar.exe
	$Go = Run ( "cmd.exe" )															;   
	WinWait ( "C:\WINDOWS\system32\cmd.exe" )										; ,   
	Send ( "cd /D " & $folder4 & @CRLF )											;    
	Sleep ( 100 )																	;  
If $compress1 = 1 Then
	Send ( '"' & $bsdtar & '"' & " -cvz -f " & '"' & $targetfile & '"' & " " & '"' & $folder3 & '"' & @CRLF )	;    
	ProcessWaitClose ( $Go )														;       	
Else
	Send ( '"' & $bsdtar & '"' & " -cvf " & '"' & $targetfile & '"' & " " & '"' & $folder3 & '"' & @CRLF )
	;tar -c -M --tape-length=102400 --file=disk1.tar BIGFILE
	ProcessWaitClose ( $Go )														;       	
	EndIf	
EndFunc

Func GetArchive ()
	$archivefile = FileOpenDialog( " ", "", "(*.tgz;*.tar)", 1 )
	If $targetfolder <> "" Then
	GUICtrlSetState ( $beginunpack, $GUI_ENABLE )
	EndIf
EndFunc

Func UnpackTo ()
	$targetfolder = FileSelectFolder(" ,     ", "", 1, "O:\SASPlanet\" )
	If $archivefile <> "" Then
	GUICtrlSetState ( $beginunpack, $GUI_ENABLE )
	EndIf
	EndFunc


Func Unpack ()
	$Go = Run ( "cmd.exe" )
	WinWait ( "C:\WINDOWS\system32\cmd.exe" )
	Send ( "cd /D " & $targetfolder & "\" & @CRLF )
	Sleep ( 100 )
	Send (  '"' & $bsdtar & '"' & " -v -k -xf " & '"' & $archivefile & '"' & @CRLF )
	ProcessWaitClose ( $Go )
			EndFunc

Func CLOSEClicked ()
	Exit
	EndFunc


While 1
    $msg = GUIGetMsg ()
    
    If $msg = $GUI_EVENT_CLOSE Then ExitLoop
Wend

Exit